/* 
 * Copyright 2004-2009 Rob Beverly
 * Copyright 2015-2016 The Regents of the University of California
 * All rights reserved.
 * 
 * This file is part of Spoofer.
 * 
 * Spoofer is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * Spoofer is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with Spoofer.  If not, see <http://www.gnu.org/licenses/>.
 */

/****************************************************************************
   Program:     $Id: messages.h,v 1.6 2016/05/24 21:15:08 kkeys Exp $
   Author:      Rob Beverly <rbeverly at csail.mit.edu>
   Date:        $Date: 2016/05/24 21:15:08 $
   Description: Define control message types
****************************************************************************/

#if 0
enum msg_types {DEFAULT, HELLO, PROBE_REQ, REPORT,
                TRACE, ERR, DONE, TRACEFILT,
                PROBE6_REQ, REPORT6};
#endif

/* Test probe format */
#pragma pack(2)
#define PAYLOAD_VERSION 8
#define IPV4ADDRLEN 4
#define IPV6ADDRLEN 16
#define SEQNOSIZE 14
#define HMACSIZE  16
typedef struct test {
    uint32_t ts;
    unsigned char src_addr[IPV6ADDRLEN];
    unsigned char dst_addr[IPV6ADDRLEN];
    unsigned char seqno[SEQNOSIZE];
    unsigned char hmac[HMACSIZE];
} test_t;

typedef struct probe_hdr {
    uint16_t ver; // PAYLOAD_VERSION
    uint16_t spoofed;
} probe_hdr_t;

typedef struct probe {
    probe_hdr_t hdr;
    test_t tst;
} probe_t;
#define PROBESIZE sizeof(probe_t)
#define PAYLOADSIZE (sizeof(probe_t) - HMACSIZE)

#if 0
typedef struct spoof_msg {
    uint8_t ver;
    uint8_t type;
    uint8_t flag;  /* 0 = request, 1 = response */
    uint8_t ack;   /* 0 = negative, 1 = positive */
    uint16_t len;
    uint16_t unused;
} spoof_msg_t;

typedef struct hello_msg {
    unsigned char ip[IPV6ADDRLEN];
    uint8_t dist;
    uint8_t oslen;
    uint8_t shared;  
    uint8_t unused;  
    uint32_t sessionid;
} hello_msg_t;

typedef struct report_msg {
    unsigned char src_addr[IPV6ADDRLEN];
    unsigned char dst_addr[IPV6ADDRLEN];
    uint8_t seqlen;
    uint8_t ack;	/* 0 = sendtofail, 1 = ok, 2 = host-detected NAT */
    uint16_t unused;
} report_msg_t;

typedef struct addr_list {
    uint16_t size;
    uint16_t unused;
} addr_list_t;

typedef struct tracefilter_test {
    uint8_t dist;
    uint8_t ver;
    uint16_t unused;  
    uint32_t dst_ip;
} tracefilter_test_t;
#endif

#pragma pack()
